Match = Core.class(Sprite)

function Match:init(matchObj, nameObj, textObj)
	self.matchObj = matchObj
	self.isFocus = false
	
	self:setNameObj(nameObj)
	self:addChild(self.matchObj)
	self:addLabel(self.matchObj, textObj)
	
    self:addEventListener(Event.MOUSE_DOWN, self.onMouseDown, self)
    self:addEventListener(Event.MOUSE_MOVE, self.onMouseMove, self)
    self:addEventListener(Event.MOUSE_UP, self.onMouseUp, self)
end

function Match:setNameObj(nameObj)
	self.nameObj = nameObj
end

function Match:getNameObj()
	return self.nameObj
end

function Match:addLabel(parent_sprite, label_text)
    -- Add a label for debugging.
    label = TextField.new(nil, label_text)

    -- Center the label on parent sprite.
    label:setPosition(	parent_sprite:getWidth()/2-label:getWidth()/2,
        parent_sprite:getHeight()/2+label:getHeight()/2)

    -- Add label to the parent sprite.
    parent_sprite:addChild(label)
end

function Match:onMouseDown(event)
	if self:hitTestPoint(event.x, event.y) then
		self.isFocus = true		
		
		self.x0 = event.x
        self.y0 = event.y
		setValue(false)
		event:stopPropagation()
	end
end

function Match:onMouseMove(event)
    if self.isFocus then
	
        local dx = event.x - self.x0
        local dy = event.y - self.y0
		
        self:setX(self:getX() + dx)
        self:setY(self:getY() + dy)
		
        self.x0 = event.x
        self.y0 = event.y
		
        event:stopPropagation()
    end
end

function Match:onMouseUp(event)
    if self.isFocus then
		self.isFocus = false
		if getValue() then
			print("Object released inside the box")
			self:removeChild(self.downState)
		end
		
        event:stopPropagation()
    end
end
